/* UDPtime.c - main 
# 	Cesar Kallas	RA: 02099224
#	cesarkallas (at) gmx.net 	-	 http://cesarkallas.soulivre.org
#	Pontificia Universidade Catolica - Campinas
#	08/2005
*/

#include <sys/types.h>

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <pthread.h>			/* para poder manipular threads */
#define	BUFSIZE 64

#define	UNIXEPOCH	2208988800UL	/* UNIX epoch, in UCT secs	*/
#define	MSG		"what time is it?\n"
char msg[9500000];


#define NUM_THREADS 500
pthread_t clientes[NUM_THREADS];

int	errno;
	char	*host = "localhost";	/* host to use if none supplied	*/
	char	*service = "time";	/* default service name		*/
	time_t	now;			/* 32-bit integer to hold time	*/ 
	int	s, n;			/* socket descriptor, read count*/

int	connectUDP(const char *host, const char *service);
int	errexit(const char *format, ...);

/*------------------------------------------------------------------------
 * main - UDP client for TIME service that prints the resulting time
 *------------------------------------------------------------------------
 */
int respostas=0; 
void cliente(void *threadid)
{
	
	printf("Cliente #%d \n", threadid);
	s = connectUDP(host, service);

	strcat(msg, "what time is it");
	strcat(msg, "\0");
	//printf("\nmsg= %s", msg);
	(void) write(s, MSG, strlen(MSG));

	/* Read the time */

	n = read(s, (char *)&now, sizeof(now));
	if (n < 0)
		errexit("read failed: %s\n", strerror(errno));
	now = ntohl((unsigned long)now);	/* put in host order	*/
	now -= UNIXEPOCH;		/* convert UCT to UNIX epoch	*/

	printf("%d: %s", respostas, ctime(&now));
	respostas++;	
	pthread_exit(NULL);
}
 
int
main(int argc, char *argv[])
{

	strcpy(msg, "what time is it");
	strcat(msg, "\0");
	switch (argc) {
	case 1:
		host = "localhost";
		break;
	case 3:
		service = argv[2];
		/* FALL THROUGH */
	case 2:
		host = argv[1];
		break;
	default:
		fprintf(stderr, "usage: UDPtime [host [port]]\n");
		exit(1);
	}
	printf("\numero threads: %d", NUM_THREADS);
	
	int i, ts, rc, status;
	
	for (i=0;i<NUM_THREADS;i++) {

	// tenta criar um thread consumidor
	    ts = pthread_create(&clientes[i], NULL, cliente, (void *)i+1);
		if (ts) {
		  printf("ERRO: impossivel criar um thread \n");
		  exit(-1);	
		}
	}
	for(i=0; i<NUM_THREADS; i++){
		rc = pthread_join(clientes[i], (void **)&status);
		if(rc){
			printf("ERROR; return code from pthread_join() is%d\n", rc);
			exit(-1);
		}
	}
	
  printf("Terminando o thread main(), respotas: %d\n", respostas);
  pthread_exit(NULL);
	exit(0);
}


